static const char *RcsId     = "$Header:  $";
static const char *TagName   = "$Name:  $";
static const char *HttpServer= "http://www.esrf.fr/computing/cs/tango/tango_doc/ds_doc/";
//+=============================================================================
//
// file :        DiffractometerClass.cpp
//
// description : C++ source for the DiffractometerClass. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the Diffractometer once per process.
//
// project :     TANGO Device Server
//
// $Author:  $
//
// $Revision:  $
//
// $Log:  $
//
// copyleft :   European Synchrotron Radiation Facility
//              BP 220, Grenoble 38043
//              FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================


#include <tango.h>

#include <Diffractometer.h>
#include <DiffractometerClass.h>


//+----------------------------------------------------------------------------
/**
 *	Create DiffractometerClass singleton and return it in a C function for Python usage
 */
//+----------------------------------------------------------------------------
extern "C" {
#ifdef WIN32

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_Diffractometer_class(const char *name) {
		return Diffractometer_ns::DiffractometerClass::init(name);
	}
}


namespace Diffractometer_ns
{

//+----------------------------------------------------------------------------
//
// method : 		AbortCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *AbortCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "AbortCmd::execute(): arrived" << endl;

	((static_cast<Diffractometer *>(device))->abort());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		AddNewCrystalClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *AddNewCrystalClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "AddNewCrystalClass::execute(): arrived" << endl;

	Tango::DevString	argin;
	extract(in_any, argin);

	((static_cast<Diffractometer *>(device))->add_new_crystal(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		AddReflectionClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *AddReflectionClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "AddReflectionClass::execute(): arrived" << endl;

	const Tango::DevVarDoubleArray	*argin;
	extract(in_any, argin);

	((static_cast<Diffractometer *>(device))->add_reflection(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		AffineCrystalCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *AffineCrystalCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "AffineCrystalCmd::execute(): arrived" << endl;

	Tango::DevString	argin;
	extract(in_any, argin);

	return insert((static_cast<Diffractometer *>(device))->affine_crystal(argin));
}

//+----------------------------------------------------------------------------
//
// method : 		ComputeUCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *ComputeUCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "ComputeUCmd::execute(): arrived" << endl;

	const Tango::DevVarLongArray	*argin;
	extract(in_any, argin);

	((static_cast<Diffractometer *>(device))->compute_u(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		ConfigureCrystalCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *ConfigureCrystalCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "ConfigureCrystalCmd::execute(): arrived" << endl;

	const Tango::DevVarDoubleArray	*argin;
	extract(in_any, argin);

	((static_cast<Diffractometer *>(device))->configure_crystal(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		CopyCurrentCrystalAsClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *CopyCurrentCrystalAsClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "CopyCurrentCrystalAsClass::execute(): arrived" << endl;

	Tango::DevString	argin;
	extract(in_any, argin);

	((static_cast<Diffractometer *>(device))->copy_current_crystal_as(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		CopyReflectionToCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *CopyReflectionToCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "CopyReflectionToCmd::execute(): arrived" << endl;

	const Tango::DevVarDoubleStringArray	*argin;
	extract(in_any, argin);

	((static_cast<Diffractometer *>(device))->copy_reflection_to(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		DeleteCurrentCrystalClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *DeleteCurrentCrystalClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "DeleteCurrentCrystalClass::execute(): arrived" << endl;

	((static_cast<Diffractometer *>(device))->delete_current_crystal());
	return new CORBA::Any();
}


//+----------------------------------------------------------------------------
//
// method : 		GetCrystalParameterValuesCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetCrystalParameterValuesCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetCrystalParameterValuesCmd::execute(): arrived" << endl;

	Tango::DevString	argin;
	extract(in_any, argin);

	return insert((static_cast<Diffractometer *>(device))->get_crystal_parameter_values(argin));
}

//+----------------------------------------------------------------------------
//
// method : 		LoadClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *LoadClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "LoadClass::execute(): arrived" << endl;

	((static_cast<Diffractometer *>(device))->load());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		RemoveReflectionClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *RemoveReflectionClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "RemoveReflectionClass::execute(): arrived" << endl;

	Tango::DevShort	argin;
	extract(in_any, argin);

	((static_cast<Diffractometer *>(device))->remove_reflection(argin));
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		SaveClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *SaveClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "SaveClass::execute(): arrived" << endl;

	((static_cast<Diffractometer *>(device))->save());
	return new CORBA::Any();
}


//+----------------------------------------------------------------------------
//
// method : 		SetCrystalParameterValuesClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *SetCrystalParameterValuesClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "SetCrystalParameterValuesClass::execute(): arrived" << endl;

	const Tango::DevVarDoubleStringArray	*argin;
	extract(in_any, argin);

	((static_cast<Diffractometer *>(device))->set_crystal_parameter_values(argin));
	return new CORBA::Any();
}


//
//----------------------------------------------------------------
//	Initialize pointer for singleton pattern
//----------------------------------------------------------------
//
DiffractometerClass *DiffractometerClass::_instance = NULL;

//+----------------------------------------------------------------------------
//
// method : 		DiffractometerClass::DiffractometerClass(string &s)
// 
// description : 	constructor for the DiffractometerClass
//
// in : - s : The class name
//
//-----------------------------------------------------------------------------
DiffractometerClass::DiffractometerClass(string &s):DeviceClass(s)
{

	cout2 << "Entering DiffractometerClass constructor" << endl;
	set_default_property();
	get_class_property();
	write_class_property();
	
	cout2 << "Leaving DiffractometerClass constructor" << endl;

}
//+----------------------------------------------------------------------------
//
// method : 		DiffractometerClass::~DiffractometerClass()
// 
// description : 	destructor for the DiffractometerClass
//
//-----------------------------------------------------------------------------
DiffractometerClass::~DiffractometerClass()
{
	_instance = NULL;
}

//+----------------------------------------------------------------------------
//
// method : 		DiffractometerClass::instance
// 
// description : 	Create the object if not already done. Otherwise, just
//			return a pointer to the object
//
// in : - name : The class name
//
//-----------------------------------------------------------------------------
DiffractometerClass *DiffractometerClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new DiffractometerClass(s);
		}
		catch (bad_alloc)
		{
			throw;
		}		
	}		
	return _instance;
}

DiffractometerClass *DiffractometerClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}

//+----------------------------------------------------------------------------
//
// method : 		DiffractometerClass::command_factory
// 
// description : 	Create the command object(s) and store them in the 
//			command list
//
//-----------------------------------------------------------------------------
void DiffractometerClass::command_factory()
{
	command_list.push_back(new AbortCmd("Abort",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new AddNewCrystalClass("AddNewCrystal",
		Tango::DEV_STRING, Tango::DEV_VOID,
		"Name of the new crystal",
		"",
		Tango::OPERATOR));
	command_list.push_back(new AddReflectionClass("AddReflection",
		Tango::DEVVAR_DOUBLEARRAY, Tango::DEV_VOID,
		"reflections i.e :  h, k, l, relevance, enable/disable",
		"",
		Tango::OPERATOR));
	command_list.push_back(new AffineCrystalCmd("AffineCrystal",
		Tango::DEV_STRING, Tango::DEV_DOUBLE,
		"name of the crystal to fit",
		"the fitness of the crystal after the affinement.",
		Tango::OPERATOR));
	command_list.push_back(new ComputeUCmd("ComputeU",
		Tango::DEVVAR_LONGARRAY, Tango::DEV_VOID,
		"a two elements array with the index of reflection to use",
		"",
		Tango::OPERATOR));
	command_list.push_back(new ConfigureCrystalCmd("ConfigureCrystal",
		Tango::DEVVAR_DOUBLEARRAY, Tango::DEV_VOID,
		"Crystal parameters : alpha,beta,gamma, A,B,C",
		"",
		Tango::OPERATOR));
	command_list.push_back(new CopyCurrentCrystalAsClass("CopyCurrentCrystalAs",
		Tango::DEV_STRING, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new CopyReflectionToCmd("CopyReflectionTo",
		Tango::DEVVAR_DOUBLESTRINGARRAY, Tango::DEV_VOID,
		"Double: Reflection number of the current crystal String : Name of the crystal where copy this reflection",
		"",
		Tango::OPERATOR));
	command_list.push_back(new DeleteCurrentCrystalClass("DeleteCurrentCrystal",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetCrystalParameterValuesCmd("GetCrystalParameterValues",
		Tango::DEV_STRING, Tango::DEVVAR_DOUBLESTRINGARRAY,
		"Name of parameter (see getParametersNames for the complete list of parameters)",
		"In the order : minimum value, maximum value, affinement enable",
		Tango::OPERATOR));
	command_list.push_back(new LoadClass("Load",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::EXPERT));
	command_list.push_back(new RemoveReflectionClass("RemoveReflection",
		Tango::DEV_SHORT, Tango::DEV_VOID,
		"index of reflection to remove",
		"",
		Tango::OPERATOR));
	command_list.push_back(new SaveClass("Save",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::EXPERT));
	command_list.push_back(new SetCrystalParameterValuesClass("SetCrystalParameterValues",
		Tango::DEVVAR_DOUBLESTRINGARRAY, Tango::DEV_VOID,
		"String : Name of parameter ; Double : min value, max value, affinement enable",
		"",
		Tango::OPERATOR));

	//	add polling if any
	for (unsigned int i=0 ; i<command_list.size(); i++)
	{
	}
}

//+----------------------------------------------------------------------------
//
// method : 		DiffractometerClass::get_class_property
// 
// description : 	Get the class property for specified name.
//
// in :		string	name : The property name
//
//+----------------------------------------------------------------------------
Tango::DbDatum DiffractometerClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		DiffractometerClass::get_default_device_property()
// 
// description : 	Return the default value for device property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum DiffractometerClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//+----------------------------------------------------------------------------
//
// method : 		DiffractometerClass::get_default_class_property()
// 
// description : 	Return the default value for class property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum DiffractometerClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		DiffractometerClass::device_factory
// 
// description : 	Create the device object(s) and store them in the 
//			device list
//
// in :		Tango::DevVarStringArray *devlist_ptr : The device name list
//
//-----------------------------------------------------------------------------
void DiffractometerClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{

	//	Create all devices.(Automatic code generation)
	//-------------------------------------------------------------
	for (unsigned long i=0 ; i < devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
						
		// Create devices and add it into the device list
		//----------------------------------------------------
		device_list.push_back(new Diffractometer(this, (*devlist_ptr)[i]));							 

		// Export device to the outside world
		// Check before if database used.
		//---------------------------------------------
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(device_list.back());
		else
			export_device(device_list.back(), (*devlist_ptr)[i]);
	}
	//	End of Automatic code generation
	//-------------------------------------------------------------
}
//+----------------------------------------------------------------------------
//	Method: DiffractometerClass::attribute_factory(vector<Tango::Attr *> &att_list)
//-----------------------------------------------------------------------------
void DiffractometerClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	//	Attribute : AnglesIdx
	AnglesIdxAttrib	*angles_idx = new AnglesIdxAttrib();
	Tango::UserDefaultAttrProp	angles_idx_prop;
	angles_idx_prop.set_description("this attribut select the solution used to set the axes after an angle computation.");
	angles_idx->set_default_properties(angles_idx_prop);
	att_list.push_back(angles_idx);

	//	Attribute : AutoUpdateFromProxies
	AutoUpdateFromProxiesAttrib	*auto_update_from_proxies = new AutoUpdateFromProxiesAttrib();
	Tango::UserDefaultAttrProp	auto_update_from_proxies_prop;
	auto_update_from_proxies_prop.set_format("%1d");
	auto_update_from_proxies_prop.set_max_value("1");
	auto_update_from_proxies_prop.set_min_value("0");
	auto_update_from_proxies_prop.set_description("0 : Device do not update the simulated part using proxies\n1 : Device update all the times the simulated part from the proxies\n");
	auto_update_from_proxies->set_default_properties(auto_update_from_proxies_prop);
	att_list.push_back(auto_update_from_proxies);

	//	Attribute : WaveLength
	WaveLengthAttrib	*wave_length = new WaveLengthAttrib();
	Tango::UserDefaultAttrProp	wave_length_prop;
	wave_length_prop.set_label("wavelength");
	wave_length_prop.set_format("%8.3f");
	wave_length_prop.set_description("The wave length used by the diffractometer.\nUsually connected to an AttributeProxy.");
	wave_length->set_default_properties(wave_length_prop);
	wave_length->set_memorized();
	wave_length->set_memorized_init(true);
	att_list.push_back(wave_length);

	//	Attribute : Crystal
	CrystalAttrib	*crystal = new CrystalAttrib();
	Tango::UserDefaultAttrProp	crystal_prop;
	crystal_prop.set_label("crystal");
	crystal_prop.set_description("The name of the crystal used by the diffractometer.\n\nthe list of the available crystals is in the attribut crystals \n");
	crystal->set_default_properties(crystal_prop);
	att_list.push_back(crystal);

	//	Attribute : A
	AAttrib	*a = new AAttrib();
	Tango::UserDefaultAttrProp	a_prop;
	a_prop.set_format("%8.3f");
	a_prop.set_description("crystal lattice a parameter");
	a->set_default_properties(a_prop);
	att_list.push_back(a);

	//	Attribute : AFit
	AFitAttrib	*afit = new AFitAttrib();
	Tango::UserDefaultAttrProp	afit_prop;
	afit_prop.set_description("Activate/UnActivate the fit of the parameter");
	afit->set_default_properties(afit_prop);
	att_list.push_back(afit);

	//	Attribute : B
	BAttrib	*b = new BAttrib();
	Tango::UserDefaultAttrProp	b_prop;
	b_prop.set_format("%8.3f");
	b_prop.set_description("crystal lattice b parameter");
	b->set_default_properties(b_prop);
	att_list.push_back(b);

	//	Attribute : BFit
	BFitAttrib	*bfit = new BFitAttrib();
	Tango::UserDefaultAttrProp	bfit_prop;
	bfit_prop.set_description("Activate/UnActivate the fit of the parameter");
	bfit->set_default_properties(bfit_prop);
	att_list.push_back(bfit);

	//	Attribute : C
	CAttrib	*c = new CAttrib();
	Tango::UserDefaultAttrProp	c_prop;
	c_prop.set_format("%8.3f");
	c_prop.set_description("crystal lattice c parameter");
	c->set_default_properties(c_prop);
	att_list.push_back(c);

	//	Attribute : CFit
	CFitAttrib	*cfit = new CFitAttrib();
	Tango::UserDefaultAttrProp	cfit_prop;
	cfit_prop.set_description("Activate/UnActivate the fit of the parameter");
	cfit->set_default_properties(cfit_prop);
	att_list.push_back(cfit);

	//	Attribute : Alpha
	AlphaAttrib	*alpha = new AlphaAttrib();
	Tango::UserDefaultAttrProp	alpha_prop;
	alpha_prop.set_unit("degree");
	alpha_prop.set_format("%8.3f");
	alpha_prop.set_description("crystal lattice alpha parameter");
	alpha->set_default_properties(alpha_prop);
	att_list.push_back(alpha);

	//	Attribute : AlphaFit
	AlphaFitAttrib	*alpha_fit = new AlphaFitAttrib();
	Tango::UserDefaultAttrProp	alpha_fit_prop;
	alpha_fit_prop.set_description("Activate/UnActivate the fit of the parameter");
	alpha_fit->set_default_properties(alpha_fit_prop);
	att_list.push_back(alpha_fit);

	//	Attribute : Beta
	BetaAttrib	*beta = new BetaAttrib();
	Tango::UserDefaultAttrProp	beta_prop;
	beta_prop.set_unit("degree");
	beta_prop.set_format("%8.3f");
	beta_prop.set_description("crystal lattice beta parameter");
	beta->set_default_properties(beta_prop);
	att_list.push_back(beta);

	//	Attribute : BetaFit
	BetaFitAttrib	*beta_fit = new BetaFitAttrib();
	Tango::UserDefaultAttrProp	beta_fit_prop;
	beta_fit_prop.set_description("Activate/UnActivate the fit of the parameter");
	beta_fit->set_default_properties(beta_fit_prop);
	att_list.push_back(beta_fit);

	//	Attribute : Gamma
	GammaAttrib	*gamma = new GammaAttrib();
	Tango::UserDefaultAttrProp	gamma_prop;
	gamma_prop.set_unit("degree");
	gamma_prop.set_format("%8.3f");
	gamma_prop.set_description("crystal lattice gamma parameter");
	gamma->set_default_properties(gamma_prop);
	att_list.push_back(gamma);

	//	Attribute : GammaFit
	GammaFitAttrib	*gamma_fit = new GammaFitAttrib();
	Tango::UserDefaultAttrProp	gamma_fit_prop;
	gamma_fit_prop.set_description("Activate/UnActivate the fit of the parameter");
	gamma_fit->set_default_properties(gamma_fit_prop);
	att_list.push_back(gamma_fit);

	//	Attribute : Ux
	UxAttrib	*ux = new UxAttrib();
	Tango::UserDefaultAttrProp	ux_prop;
	ux_prop.set_unit("degree");
	ux_prop.set_description("The x coordinate of the U matrix");
	ux->set_default_properties(ux_prop);
	att_list.push_back(ux);

	//	Attribute : UxFit
	UxFitAttrib	*ux_fit = new UxFitAttrib();
	Tango::UserDefaultAttrProp	ux_fit_prop;
	ux_fit_prop.set_description("Activate/UnActivate the fit of the parameter");
	ux_fit->set_default_properties(ux_fit_prop);
	att_list.push_back(ux_fit);

	//	Attribute : Uy
	UyAttrib	*uy = new UyAttrib();
	Tango::UserDefaultAttrProp	uy_prop;
	uy_prop.set_unit("degree");
	uy_prop.set_description("The y coordinate of the U matrix");
	uy->set_default_properties(uy_prop);
	att_list.push_back(uy);

	//	Attribute : UyFit
	UyFitAttrib	*uy_fit = new UyFitAttrib();
	Tango::UserDefaultAttrProp	uy_fit_prop;
	uy_fit_prop.set_description("Activate/UnActivate the fit of the parameter");
	uy_fit->set_default_properties(uy_fit_prop);
	att_list.push_back(uy_fit);

	//	Attribute : Uz
	UzAttrib	*uz = new UzAttrib();
	Tango::UserDefaultAttrProp	uz_prop;
	uz_prop.set_unit("degree");
	uz_prop.set_description("The z coordinate of the U matrix");
	uz->set_default_properties(uz_prop);
	att_list.push_back(uz);

	//	Attribute : UzFit
	UzFitAttrib	*uz_fit = new UzFitAttrib();
	Tango::UserDefaultAttrProp	uz_fit_prop;
	uz_fit_prop.set_description("Activate/UnActivate the fit of the parameter");
	uz_fit->set_default_properties(uz_fit_prop);
	att_list.push_back(uz_fit);

	//	Attribute : AStar
	AStarAttrib	*astar = new AStarAttrib();
	Tango::UserDefaultAttrProp	astar_prop;
	astar_prop.set_description("The a* crystal parameter");
	astar->set_default_properties(astar_prop);
	att_list.push_back(astar);

	//	Attribute : BStar
	BStarAttrib	*bstar = new BStarAttrib();
	Tango::UserDefaultAttrProp	bstar_prop;
	bstar_prop.set_description("The b* crystal parameter");
	bstar->set_default_properties(bstar_prop);
	att_list.push_back(bstar);

	//	Attribute : CStar
	CStarAttrib	*cstar = new CStarAttrib();
	Tango::UserDefaultAttrProp	cstar_prop;
	cstar_prop.set_description("The c* crystal parameter");
	cstar->set_default_properties(cstar_prop);
	att_list.push_back(cstar);

	//	Attribute : AlphaStar
	AlphaStarAttrib	*alpha_star = new AlphaStarAttrib();
	Tango::UserDefaultAttrProp	alpha_star_prop;
	alpha_star_prop.set_description("The alpha* crystal parameter");
	alpha_star->set_default_properties(alpha_star_prop);
	att_list.push_back(alpha_star);

	//	Attribute : BetaStar
	BetaStarAttrib	*beta_star = new BetaStarAttrib();
	Tango::UserDefaultAttrProp	beta_star_prop;
	beta_star_prop.set_description("The beta* crystal parameter");
	beta_star->set_default_properties(beta_star_prop);
	att_list.push_back(beta_star);

	//	Attribute : GammaStar
	GammaStarAttrib	*gamma_star = new GammaStarAttrib();
	Tango::UserDefaultAttrProp	gamma_star_prop;
	gamma_star_prop.set_description("The beta* crystal parameter");
	gamma_star->set_default_properties(gamma_star_prop);
	att_list.push_back(gamma_star);

	//	Attribute : Simulated
	SimulatedAttrib	*simulated = new SimulatedAttrib();
	Tango::UserDefaultAttrProp	simulated_prop;
	simulated_prop.set_label("simulated");
	simulated_prop.set_format("%1d");
	simulated_prop.set_max_value("1");
	simulated_prop.set_min_value("0");
	simulated_prop.set_description("0 : Device REALLY moves diffractometers motors\n1 : Device only simulates calculations and DOES NOT move any motor\n");
	simulated->set_default_properties(simulated_prop);
	att_list.push_back(simulated);

	//	Attribute : CrystalNames
	CrystalNamesAttrib	*crystal_names = new CrystalNamesAttrib();
	att_list.push_back(crystal_names);

	//	Attribute : AxesNames
	AxesNamesAttrib	*axes_names = new AxesNamesAttrib();
	Tango::UserDefaultAttrProp	axes_names_prop;
	axes_names_prop.set_description("the names of the Dynamic axis attributes");
	axes_names->set_default_properties(axes_names_prop);
	att_list.push_back(axes_names);

	//	Attribute : pseudoAxesProxies
	pseudoAxesProxiesAttrib	*pseudo_axes_proxies = new pseudoAxesProxiesAttrib();
	att_list.push_back(pseudo_axes_proxies);

	//	Attribute : Angles
	AnglesAttrib	*angles = new AnglesAttrib();
	Tango::UserDefaultAttrProp	angles_prop;
	angles_prop.set_description("containe all the hkl computed values.\nsimulated (0/1) h, k, l, axies angles");
	angles->set_default_properties(angles_prop);
	att_list.push_back(angles);

	//	Attribute : AnglesDegenerated
	AnglesDegeneratedAttrib	*angles_degenerated = new AnglesDegeneratedAttrib();
	Tango::UserDefaultAttrProp	angles_degenerated_prop;
	angles_degenerated_prop.set_description("containe all the hkl computed values.\nsimulated (0/1) h, k, l, axies angles");
	angles_degenerated->set_default_properties(angles_degenerated_prop);
	att_list.push_back(angles_degenerated);

	//	Attribute : AnglesRangeCheck
	AnglesRangeCheckAttrib	*angles_range_check = new AnglesRangeCheckAttrib();
	Tango::UserDefaultAttrProp	angles_range_check_prop;
	angles_range_check_prop.set_description("containe all the hkl computed values.\nsimulated (0/1) h, k, l, axies angles");
	angles_range_check->set_default_properties(angles_range_check_prop);
	att_list.push_back(angles_range_check);

	//	Attribute : Reflections
	ReflectionsAttrib	*reflections = new ReflectionsAttrib();
	att_list.push_back(reflections);

	//	Attribute : ReflectionsAngles
	ReflectionsAnglesAttrib	*reflections_angles = new ReflectionsAnglesAttrib();
	Tango::UserDefaultAttrProp	reflections_angles_prop;
	reflections_angles_prop.set_description("matrix with the theoretical (lower triangular part) and\nmesured angles (upper triangular part) between\nreflections.");
	reflections_angles->set_default_properties(reflections_angles_prop);
	att_list.push_back(reflections_angles);

	//	Attribute : UB
	UBAttrib	*ub = new UBAttrib();
	Tango::UserDefaultAttrProp	ub_prop;
	ub_prop.set_description("The UB matrix of the current crystal");
	ub->set_default_properties(ub_prop);
	att_list.push_back(ub);

	//	End of Automatic code generation
	//-------------------------------------------------------------
}

//+----------------------------------------------------------------------------
//
// method : 		DiffractometerClass::get_class_property()
// 
// description : 	Read the class properties from database.
//
//-----------------------------------------------------------------------------
void DiffractometerClass::get_class_property()
{
	//	Initialize your default values here (if not done with  POGO).
	//------------------------------------------------------------------

	//	Read class properties from database.(Automatic code generation)
	//------------------------------------------------------------------

	//	Call database and extract values
	//--------------------------------------------
	if (Tango::Util::instance()->_UseDb==true)
		get_db_class()->get_property(cl_prop);
	Tango::DbDatum	def_prop;
	int	i = -1;


	//	End of Automatic code generation
	//------------------------------------------------------------------

}

//+----------------------------------------------------------------------------
//
// method : 	DiffractometerClass::set_default_property
// 
// description: Set default property (class and device) for wizard.
//              For each property, add to wizard property name and description
//              If default value has been set, add it to wizard property and
//              store it in a DbDatum.
//
//-----------------------------------------------------------------------------
void DiffractometerClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;

	vector<string>	vect_data;
	//	Set Default Class Properties
	//	Set Default Device Properties
	prop_name = "TauConstant";
	prop_desc = "Definition of the Tau constant .\nPossible values are pi or 1 .\nDefault : 1";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "RealAxisProxies";
	prop_desc = "";
	prop_def  = "mu:tests/diffabs/mu\nkomega:tests/diffabs/komega\nkappa:tests/diffabs/kappa\nkphi:tests/diffabs/kphi\ndelta:tests/diffabs/delta\ngamma:tests/diffabs/gamma";
	vect_data.clear();
	vect_data.push_back("mu:tests/diffabs/mu");
	vect_data.push_back("komega:tests/diffabs/komega");
	vect_data.push_back("kappa:tests/diffabs/kappa");
	vect_data.push_back("kphi:tests/diffabs/kphi");
	vect_data.push_back("delta:tests/diffabs/delta");
	vect_data.push_back("gamma:tests/diffabs/gamma");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "LambdaAttributeProxy";
	prop_desc = "The name of the lambda attribute proxy.\n\nThe diffractometer use it to read the lambda value from another Device";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "DiffractometerType";
	prop_desc = "The Type of the diffractometer\n\n";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "ProtectReflectionAxes";
	prop_desc = "allow or not to change the values of the axes in the Reflections attribute.\n\nset this properties to false to allow writting on the axes values.";
	prop_def  = "true";
	vect_data.clear();
	vect_data.push_back("true");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

}
//+----------------------------------------------------------------------------
//
// method : 		DiffractometerClass::write_class_property
// 
// description : 	Set class description as property in database
//
//-----------------------------------------------------------------------------
void DiffractometerClass::write_class_property()
{
	//	First time, check if database used
	//--------------------------------------------
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("Diffractometer");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("This class can be used to compute cristallography computation");
	description << str_desc;
	data.push_back(description);
		
	//	put cvs location
	string	rcsId(RcsId);
	string	filename(classname);
	start = rcsId.find("/");
	if (start!=string::npos)
	{
		filename += "Class.cpp";
		end   = rcsId.find(filename);
		if (end>start)
		{
			string	strloc = rcsId.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	//	Get CVS tag revision
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("Device_4Impl");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	//--------------------------------------------
	get_db_class()->put_property(data);
}

}	// namespace
